image: node:10

stages:
  - build
  - test
  - deploy review
  - deploy staging
  - deploy production
  - production tests

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/
    
variables:
  STAGING_DOMAIN: leti-staging.surge.sh
  PRODUCTION_DOMAIN: leti.surge.sh

build website:
  stage: build
  only:
    - master
    - merge_requests
  before_script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm install -g gatsby-cli
  script:
    - gatsby build
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
  artifacts:
    paths:
      - ./public

test artifact:
  image: alpine
  stage: test
  only:
    - master
    - merge_requests
  script:
    - grep -q "Gatsby" ./public/index.html

deploy review:
  stage: deploy review
  only:
    - merge_requests
  environment:
      name: review/$CI_COMMIT_REF_NAME
      url: https://leti-$CI_ENVIRONMENT_SLUG.surge.sh
      on_stop: stop review
  before_script:
    - npm install --global surge
  script:
    - surge --project ./public --domain leti-$CI_ENVIRONMENT_SLUG.surge.sh
    
stop review:
  stage: deploy review
  only:
    - merge_requests
  variables:
    GIT_STRATEGY: none
  script:
    - npm install --global surge
    - surge teardown leti-$CI_ENVIRONMENT_SLUG.surge.sh
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop

deploy staging:
  stage: deploy staging
  environment:
    name: staging
    url: $STAGING_DOMAIN
  only:
    - master
  before_script:
    - npm install --global surge
  script:
    - surge --project ./public --domain $STAGING_DOMAIN

deploy production: 
  stage: deploy production
  environment:
    name: production
    url: $PRODUCTION_DOMAIN
  only:
    - master
  before_script:
    - npm install --global surge
  script:
    - surge --project ./public --domain $PRODUCTION_DOMAIN

test deployment:
  image: alpine
  stage: production tests
  only:
    - master
  script:
    - apk add --no-cache curl
    - curl -s "https://leti.surge.sh" | grep -q "Hi people"
    - curl -s "https://leti.surge.sh" | grep -q "$CI_COMMIT_SHORT_SHA"
